
module double_dabble(
    input [BINARY_DIGITS-1:0] binary,
    output reg [DECIMAL_DIGITS*4-1:0] bcd);
  parameter DECIMAL_DIGITS = 3;
  parameter BINARY_DIGITS = 8;

  reg [$clog2(DECIMAL_DIGITS+1)-1:0] d = 0;
  reg [$clog2(BINARY_DIGITS+1)-1:0] i = 0;

  always @* begin
    bcd = 0;
    for (i = 0; i < BINARY_DIGITS; i=i+1) begin
      for (d = 0; d < DECIMAL_DIGITS; d=d+1)
        if (bcd[d*4+4-1 -:4] > 4) bcd[d*4+4-1 -:4] = bcd[d*4+4-1 -:4] + 3;
      bcd = {bcd, binary[BINARY_DIGITS-1-i]};
    end
  end
  
endmodule
